.586    
.model flat,stdcall
option casemap:none

WinMain             PROTO   :DWORD,:DWORD,:DWORD,:DWORD
CreateControls      PROTO   :DWORD
Local_CreateMenu    PROTO   :DWORD
EditProc            PROTO   :DWORD,:DWORD,:DWORD,:DWORD
ToolbarProc         PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

NoButtons           equ     9

MaxAllocHandles     equ     10
TooltipID           equ     500h
NoToolbarTooltips   equ     7
.data

ALLOC_STRUCT    STRUCT

AllocHandle     dd      ?
lpAlloc         LPSTR   ?

ALLOC_STRUCT    ENDS

hInstance       dd      ?
CommandLine     LPSTR   ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0

MainWindowName  db      'Rich Edit Control Example v1.0',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>
cxScreen        dd          ?
cyScreen        dd          ?

; ++++ Toolbar related +++++

hToolbar        dd          ?
ToolbarClass    db      'ToolbarWindow32',0
TBButtons       TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <1,1,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <2,2,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <NULL,NULL,TBSTATE_ENABLED,TBSTYLE_SEP,NULL,NULL>
                TBBUTTON    <3,3,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <4,4,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <5,5,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <6,6,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <NULL,NULL,TBSTATE_ENABLED,TBSTYLE_SEP,NULL,NULL>
                TBBUTTON    <NULL,7,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
ToolbarReservedY        dd          ?
lpOldToolbarProc        dd          ?

ToolbarStrings   LABEL   DWORD
szNew   db      'New',0
szOpen  db      'Open',0
szSave  db      'Save',0
CopyString  db      'Copy',0
PasteString db      'Paste',0
UndoString  db      'Undo',0
RedoString  db      'Redo',0
iButton     dd          0

; ++++ Tooltips related +++++

TooltipClass    db      'tooltips_class32',0
hTooltips       dd              ?
ti          TOOLINFO        <>

; ++++ RichEdit related +++++

szRichEdit      db      'riched20.dll',0
hRichEditLib    dd          ?
RichEditClass   db      'RichEdit20A',0
hRichEdit       dd          ?
lpOldEditProc   dd          ?
StreamStruct    EDITSTREAM  <0,0,offset StreamInProc>
SelFirst        dd          ?
SelLast         dd          ?

rect        RECT        <>
szFile      db      '.\re2.asm',0
hFile       dd          ?

; ++++ Error reporting +++++

szError     db      'Error!!!',0
szErrorIHV  db      'CreateFile returned INVALID_HANDLE_VALUE',0
szErrorCLL  db      'Couldnt Load RichEdit Library',0
szErrorAllocExceed    db      'Number of Selections Exceeded / Cant UNDO',0
szErrorNoSelection    db      'Nothing previously selected/ cant paste!',0

; +++++ Menu related +++++

hMenu       dd          ?

AllocHandles    ALLOC_STRUCT 10 dup(<0,0>)
lpAllocHandles  dd  offset AllocHandles
NoAllocHandles  dd  0


.code
    start:
        invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  GetCommandLine
        mov     CommandLine,eax
        invoke  InitCommonControls
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    mov     cyScreen,eax
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    mov     cxScreen,eax
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW+WS_CLIPCHILDREN+WS_CLIPSIBLINGS,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   pt:POINT
    local   stex:SETTEXTEX
    local   TempBuffer[1024]:BYTE

        
    .if uMsg==WM_DESTROY
Quit_App:    
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_CREATE
        mov edi,lParam
        .if [edi.CREATESTRUCT].hWndParent==NULL
            invoke  CreateControls,hWnd                

        .endif         
    .elseif uMsg==WM_SIZE
            invoke  SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL
            mov     eax,lParam
            push    eax
            movzx   eax,ax
            pop     ebx
            shr     ebx,16
            sub     ebx,ToolbarReservedY
            invoke  MoveWindow,hRichEdit,0,ToolbarReservedY,eax,ebx,TRUE
            
    .else            
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

StreamInProc    PROC    dwCookie:DWORD,lpBuff:DWORD,cb:DWORD,pcb:DWORD
    
    invoke  ReadFile,dwCookie,lpBuff,cb,pcb,NULL
    xor eax,1
    ret

StreamInProc    endp

StreamOutProc   PROC    dwCookie:DWORD,lpBuff:DWORD,cb:DWORD,pcb:DWORD

    invoke  WriteFile,dwCookie,lpBuff,cb,pcb,NULL
    xor     eax,TRUE
    ret
    
StreamOutProc   endp

SetImageList    PROC

    local   hList:DWORD
    local   hBitmap:DWORD,hBitmapMask:DWORD
    
    invoke  ImageList_Create,24,24,ILC_COLOR32+ILC_MASK,7,7
    mov     hList,eax
    invoke  SendMessage,hToolbar,TB_SETIMAGELIST,NULL,hList
    mov     edi,100
    mov     ecx,7
looper:
    push    ecx
    invoke  LoadImage,hInstance,edi,IMAGE_BITMAP,24,24,LR_SHARED
    mov     hBitmap,eax
    inc     edi
    invoke  LoadImage,hInstance,edi,IMAGE_BITMAP,24,24,LR_SHARED
    mov     hBitmapMask,eax
    inc     edi
    invoke  ImageList_Add,hList,hBitmap,hBitmapMask
    invoke  DeleteObject,hBitmap
    invoke  DeleteObject,hBitmapMask
    pop     ecx
    dec     ecx
    jcxz    end_looper
    jmp     looper
end_looper:
    ret

SetImageList    endp        
    
Local_CreateMenu    PROC    hWnd:DWORD

    local   mii:MENUITEMINFO
    
    invoke  CreatePopupMenu
    mov hMenu,eax
    invoke  SetMenu,hWnd,hMenu
    mov mii.cbSize,sizeof mii
    mov mii.fMask,MIIM_DATA+MIIM_TYPE+MIIM_ID
    mov mii.fType,MFT_STRING
    mov mii.wID,3
    mov mii.dwTypeData,offset CopyString
    invoke  InsertMenuItem,hMenu,-1,TRUE,addr mii
    inc mii.wID
    mov mii.dwTypeData,offset PasteString
    invoke  InsertMenuItem,hMenu,-1,TRUE,addr mii
    inc mii.wID
    mov mii.dwTypeData,offset UndoString
    invoke  InsertMenuItem,hMenu,-1,TRUE,addr mii
    inc mii.wID
    mov mii.dwTypeData,offset RedoString
    invoke  InsertMenuItem,hMenu,-1,TRUE,addr mii
    ret

Local_CreateMenu    endp

EditProc    PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   pt:POINT
    local   stex:SETTEXTEX
    local   AllocHandle:DWORD,lpAlloc:DWORD
    
    .if uMsg==WM_RBUTTONDOWN
            invoke  GetCursorPos,addr pt
            invoke  TrackPopupMenu,hMenu,TPM_RIGHTALIGN,pt.x,pt.y,NULL,hWnd,NULL
            
    .elseif uMsg==WM_COMMAND            
        mov eax,wParam
            .if ax==3
                .if NoAllocHandles<=MaxAllocHandles
                        mov     edi,lpAllocHandles
                        cld
                        invoke  SendMessage,hRichEdit,EM_GETSEL,SelFirst,SelLast
                        mov     eax,SelLast
                        sub     eax,SelFirst
                        invoke  LocalAlloc,LPTR,eax 
                        mov     AllocHandle,eax
                        stosd
                        invoke  LocalLock,eax
                        stosd
                        mov     lpAlloc,eax
                        invoke  SendMessage,hWnd,EM_GETSELTEXT,NULL,eax
                        mov     lpAllocHandles,edi
                        inc     NoAllocHandles
                        invoke  LocalUnlock,lpAlloc
                .else
                    invoke  MessageBox,hMainWindow,addr szErrorAllocExceed,addr szError,MB_OK
                .endif                                            
            .elseif ax==4
                .if NoAllocHandles>0
                        mov     stex.flags,ST_KEEPUNDO+ST_SELECTION
                        mov     stex.codepage,860
                        mov     esi,lpAllocHandles
                        sub     esi,8
                        cld
                        lodsd
                        mov     AllocHandle,eax
                        lodsd
                        mov     lpAlloc,eax
                        invoke  SendMessage,hWnd,EM_SETTEXTEX,addr stex,eax
                        sub     esi,16
                        mov     lpAllocHandles,eax
                        dec     NoAllocHandles
                        invoke  LocalUnlock,lpAlloc
                        invoke  LocalFree,AllocHandle
                .else
                    invoke  MessageBox,hMainWindow,addr szErrorNoSelection,addr szError,MB_OK
                .endif                                            
                                                                                    
            .elseif ax==5
                invoke  SendMessage,hWnd,EM_UNDO,NULL,NULL
            .elseif ax==6
                invoke  SendMessage,hWnd,EM_REDO,NULL,NULL                
        .endif           
    .else

no_button:        
    .endif
    invoke  CallWindowProc,lpOldEditProc,hWnd,uMsg,wParam,lParam
    ret
                
EditProc    endp

CreateControls  PROC    hWnd:DWORD

                invoke  LoadLibrary,addr szRichEdit
            .if eax!=NULL

                mov     hRichEditLib,eax
                invoke  CreateWindowEx,WS_EX_STATICEDGE,addr ToolbarClass,NULL,WS_CLIPSIBLINGS+WS_CLIPCHILDREN+WS_VISIBLE+WS_CHILD+TBSTYLE_FLAT+TBSTYLE_TOOLTIPS,\
                            0,0,0,0,hWnd,NULL,hInstance,NULL
                mov     hToolbar,eax
                call    SetImageList
                invoke  SendMessage,eax,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
                invoke  SendMessage,hToolbar,TB_ADDBUTTONS,NoButtons,addr TBButtons
                invoke	SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL    
                invoke  CreateWindowEx,NULL,addr TooltipClass,NULL,WS_VISIBLE+WS_CHILD+TTS_ALWAYSTIP\
                            ,NULL,NULL,NULL,NULL,hWnd,TooltipID,hInstance,NULL
                mov     hTooltips,eax  
                mov     ti.cbSize,sizeof ti
                mov     ti.uFlags,NULL
                push    hToolbar
                pop     ti.hWnd
                lea     esi,ToolbarStrings
                mov     ecx,NoToolbarTooltips
                cld
loop_1:                
                mov     ti.lpszText,esi
                push    ecx
                invoke  SendMessage,hToolbar,TB_GETITEMRECT,iButton,addr ti.rect
                invoke  SendMessage,hTooltips,TTM_ADDTOOL,NULL,addr ti
                pop     ecx
                dec     ecx
                jcxz    end_loop_1
realign_loop:                
                lodsb   
                cmp     al,0
                jne     realign_loop
                inc     iButton
                jmp     loop_1
end_loop_1:                
                invoke  SendMessage,hToolbar,TB_SETTOOLTIPS,hTooltips,NULL                                     
                invoke  GetClientRect,hWnd,addr rect
                invoke  GetSystemMetrics,SM_CYEDGE
                shl     eax,1
                push    eax
                invoke  SendMessage,hToolbar,TB_GETBUTTONSIZE,NULL,NULL
                pop     ebx
                shr     eax,16
                add     eax,ebx
                add     eax,2
                mov     ToolbarReservedY,eax
                add     rect.top,eax
                sub     rect.bottom,eax
                invoke  CreateWindowEx,NULL,addr RichEditClass,NULL,WS_VISIBLE+WS_CHILD+ES_MULTILINE+ES_WANTRETURN\
                            +WS_HSCROLL+WS_VSCROLL,0,rect.top,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
                mov     hRichEdit,eax
                invoke  SetWindowLong,hRichEdit,GWL_WNDPROC,addr EditProc
                mov     lpOldEditProc,eax
                invoke  Local_CreateMenu,hWnd
                invoke  SendMessage,hRichEdit,EM_SETMODIFY,0,0
                invoke  SendMessage,hRichEdit,EM_EMPTYUNDOBUFFER,0,0
                invoke  CreateFile,addr szFile,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,\
                            FILE_ATTRIBUTE_NORMAL,NULL
                .if eax!=INVALID_HANDLE_VALUE                            
                    mov hFile,eax
                    mov StreamStruct.dwCookie,eax
                    invoke  SendMessage,hRichEdit,EM_STREAMIN,SF_TEXT,addr StreamStruct                            
                    invoke  CloseHandle,hFile
                    invoke  SendMessage,hRichEdit,EM_SETMODIFY,TRUE,NULL
                .else
                    invoke  MessageBox,hWnd,addr szErrorIHV,addr szError,MB_OK
                .endif                                        
            .else
                invoke  MessageBox,hWnd,addr szErrorCLL,addr szError,MB_OK
                invoke  PostQuitMessage,NULL
            .endif
            ret
            
CreateControls  endp
end start                                            
